import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

import '../../background.dart';


class AboutScreen extends StatefulWidget {
  const AboutScreen({Key? key}) : super(key: key);

  @override
  State<AboutScreen> createState() => _AboutScreenState();
}

class _AboutScreenState extends State<AboutScreen> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: SingleChildScrollView(
          child: Column(
            children: <Widget>[
              Stack(
                children: [
                  WavyHeader(),
                  Container(
                      margin: EdgeInsets.only(top: MediaQuery.of(context).size.height/6 - 20),
                      padding: EdgeInsets.fromLTRB(20, 5, 25, 5),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.end,
                        crossAxisAlignment: CrossAxisAlignment.end,
                        children: [
                          Text(
                            'About\t\t',
                            maxLines: 1,
                            style: GoogleFonts.luckiestGuy(
                              fontSize: 28,
                              color: Color(0xFF4858A7),
                              fontStyle: FontStyle.italic,
                            ),
                          ),
                          Image.asset(
                            'assets/icons/menu/ic_info.png',
                            width: 40,
                            height: 40,
                          ),
                        ],
                      )),
                ],
              ),
            ],
          )),
    );
  }
}

