import 'package:flutter/material.dart';

class InputWidgetCurrentPassword extends StatelessWidget {
  final String hintText;

  InputWidgetCurrentPassword(this.hintText);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(bottom: 15),
      child: Container(
        width: MediaQuery.of(context).size.width,
        child: Material(
          elevation: 10,
          color: Colors.white,
          shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.all(Radius.circular(10))),
          child: Padding(
            padding: EdgeInsets.only(left: 5, right: 5),
            child: TextFormField(
              controller: passwordController,
              textInputAction: TextInputAction.next,
              obscureText: true,
              decoration: InputDecoration(
                  border: InputBorder.none,
                  hintText: hintText,
                  hintStyle: TextStyle(color: Color(0xFFE1E1E1), fontSize: 16)),
            ),
          ),
        ),
      ),
    );
  }
}

class InputWidgetNewPassword extends StatelessWidget {
  final String hintText;

  InputWidgetNewPassword(this.hintText);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(bottom: 15),
      child: Container(
        width: MediaQuery.of(context).size.width,
        child: Material(
          elevation: 10,
          color: Colors.white,
          shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.all(Radius.circular(10))),
          child: Padding(
            padding: EdgeInsets.only(left: 5, right: 5),
            child: TextFormField(
              controller: newPasswordController,
              textInputAction: TextInputAction.next,
              obscureText: true,
              decoration: InputDecoration(
                  border: InputBorder.none,
                  hintText: hintText,
                  hintStyle: TextStyle(color: Color(0xFFE1E1E1), fontSize: 16)),
            ),
          ),
        ),
      ),
    );
  }
}

class InputWidgetRetypeNewPassword extends StatelessWidget {
  final String hintText;

  InputWidgetRetypeNewPassword(this.hintText);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(bottom: 15),
      child: Container(
        width: MediaQuery.of(context).size.width,
        child: Material(
          elevation: 10,
          color: Colors.white,
          shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.all(Radius.circular(10))),
          child: Padding(
            padding: EdgeInsets.only(left: 5, right: 5),
            child: TextFormField(
              controller: retypeNewPasswordController,
              textInputAction: TextInputAction.done,
              obscureText: true,
              decoration: InputDecoration(
                  border: InputBorder.none,
                  hintText: hintText,
                  hintStyle: TextStyle(color: Color(0xFFE1E1E1), fontSize: 16)),
            ),
          ),
        ),
      ),
    );
  }
}

TextEditingController passwordController = TextEditingController();
TextEditingController newPasswordController = TextEditingController();
TextEditingController retypeNewPasswordController = TextEditingController();